/*
 * Provide simple functions to read the internal ADC
 *
 * Autor: Bernhard Wrndl-Aichriedler 
 * E-Mail: bwa@berniwa.com 
 * Homepage: http://www.berniwa.com
 */

/**
 * @defgroup blib ADC Library
 *
 * @brief Provide simple functions to read the internal ADC
 *
 * @author Bernhard Wrndl-Aichriedler bwa@berniwa.com http://www.berniwa.com
 */

#ifndef _ADC_H
#define _ADC_H   1
	
	/*
	 * Conversion types
	 */ 
	typedef enum  
	{
		CONTINUOUS,	//Multiple conversions, callback if conversion is finished
		SINGLE,		//Single conversion, callback if conversion is finished
		IMMEDIATE	//Single conversion, value is returned immediately
	} adcConversionType;

	/** 
	 * @brief 	Initializes / Read an AD Channel
	 * @param 	port		AD channel to read (0 to 7)
	 * @param 	callback 	Callback function, called if conversion is finished (set to 0 in IMMEDIATE mode)
	 * @param 	type 		Conversion type (CONTINUOUS - Multiple conversions, callback if conversion is finished, SINGLE - Single conversion, callback if conversion is finished, IMMEDIATE - Single conversion, value is returned immediately)	
	 * @return 	Zero or the conversion result
	 */
	unsigned int adcInit(unsigned char port, void (*callback)(unsigned int), adcConversionType type);

#endif
