/*
 * Main include file, simplify a few functions 
 *
 * Autor: Bernhard Wrndl-Aichriedler 
 * E-Mail: bwa@berniwa.com 
 * Homepage: http://www.berniwa.com
 */

/**
 * @defgroup blib Main include
 *
 * @brief Main include file, simplify a few functions
 *
 * @author Bernhard Wrndl-Aichriedler bwa@berniwa.com http://www.berniwa.com
 */

#ifndef _DEFAULT_H
	#include "default.h"
	#include "config.h"
	#include <util/delay.h>

	/** 
	 * @brief 	Do nothing (No operation)
	 * @param 	none
	 * @return 	none
	 */	
	inline void nop()
	{
		asm("NOP");
	}

	/** 
	 * @brief 	Sleep the given number of ms
	 * @param 	mils Millisecond to sleep
	 * @return 	none
	 */
	inline void mSleep(int mils)
	{
		unsigned char i = 0;
		for(i = 0; i < mils/10; i++)
		{
			_delay_ms(10);
		}
		_delay_ms(mils%10);
	}

	/** 
	 * @brief 	Sleep the given number of us
	 * @param 	mils Microsecond to sleep
	 * @return 	none
	 */
	inline void uSleep(int mus)
	{
		_delay_us(mus);
	}

#endif
