/*
 * Read the distance using a SRF02 sonar on the i2c
 *
 * Autor: Bernhard Wrndl-Aichriedler 
 * E-Mail: bwa@berniwa.com 
 * Homepage: http://www.berniwa.com
 */

/**
 * @defgroup blib Distance Library
 *
 * @brief Read the distance using a SRF02 sonar on the i2c
 *
 * @author Bernhard Wrndl-Aichriedler bwa@berniwa.com http://www.berniwa.com
 */
#ifndef _DISTANCE_H
	#define _DISTANCE_H   1

	#ifndef I2C_ADDRESS_SONAR
	#define I2C_ADDRESS_SONAR 0xE0	
	#endif

	/**
	 * @brief Start ranging
	 * @param none
	 * @return none
	 */
	void distanceStart(void);

	/**
	 * @brief Read ranging values - start the ranging with distanceStart()
	 * @param none
	 * @return int Distance
	 */
	unsigned int distanceRead(void);

#endif
