/*
 * Read & Write from/to the internal EEPROM 
 *
 * Autor: Bernhard Wrndl-Aichriedler 
 * E-Mail: bwa@berniwa.com 
 * Homepage: http://www.berniwa.com
 */

/**
 * @defgroup blib EEPROM Library
 *
 * @brief Read & Write from/to the internal EEPROM 
 *
 * @author Bernhard Wrndl-Aichriedler bwa@berniwa.com http://www.berniwa.com
 */

#ifndef _EEPROM_H
#define _EEPROM_H   1

	/**
	 * Write to eeprom
	 * 
	 * @param int uiAddress Eeprom address
	 * @param char ucData Data to write
	 */
	void eepromWrite(unsigned int uiAddress, unsigned char ucData);

	/**
	 * Read a value from a specific eeprom address
	 * 
	 * @param int uiAddress Eeprom address  
	 * @return char Eeprom value
	 */
	unsigned char eepromRead(unsigned int uiAddress);

#endif
