/*
 * Provide the basic timer functions
 *
 * Autor: Bernhard Wrndl-Aichriedler 
 * E-Mail: bwa@berniwa.com 
 * Homepage: http://www.berniwa.com
 */

/**
 * @defgroup blib Timer Library
 *
 * @brief Provide the basic timer functions
 *
 * @author Bernhard Wrndl-Aichriedler bwa@berniwa.com http://www.berniwa.com
 */
#ifndef _TIMER_H
	#define _TIMER_H   1


	/** 
	 * @brief Initialize timer
	 * @param 	timer		Timer no.	
	 * @param	frequency	Interrupt frequency
	 * @param	callback	Callback function, call at the timer interrupt
	 * @return 	none
	 */
	void timerInit(unsigned char timer, unsigned long frequency, void (*callback)(void));

	/** 
	 * @brief Start Timer
	 * @param 	timer		Timer no. 
	 * @return 	none
	 */	
	void timerStart(unsigned char timer);

	/** 
	 * @brief Reset
	 * @param 	timer		Timer no.
	 * @return 	none
	 */	
	void timerReset(unsigned char timer);

	/** 
	 * @brief Stop Timer
	 * @param 	timer		Timer no.
	 * @return 	none
	 */	
	void timerStop(unsigned char timer);

#endif
