#include "DialogMain.h"
#include "../blib/default.h"
#include "../ui/Ui.h"
#include "../ui/Tif.h"
#include "../glcd/glcd.h"
#include "../glcd/bmp.h"

char dialog_main_files[6][10] =
{
	"home.bmp",
	"pc.bmp",
	"tv.bmp",
	"stereo.bmp",
	"video.bmp",
	"dummy.bmp"
};

unsigned char dialog_main_items = 6;
unsigned char dialog_main_page = 6;
unsigned char dialog_main_last_selected_item = 7;

unsigned char enable_flip = false, enable_xdi = true, enable_cap = false;

void dialogMainMenu(char sitem)
{
	unsigned char i = 0, k = 0, l = 0;

	sitem %= dialog_main_items;

	if(sitem != dialog_main_last_selected_item)
	{
		for(i = 0; i < 5; i++)
		{
			l = (sitem - 2) + i;			

			if(l >= 0 && l < 5)
			{
				k = i * 28;
				bmpLoad(dialog_main_files[l], dialog_main_page, k);
				glcdWriteDataLine("\x00\x00\x00\x00", 4, dialog_main_page, k+25);
				glcdWriteDataLine("\x00\x00\x00\x00", 4, dialog_main_page+1, k+25);
			}
			else
			{
				for(k = 0; k < 7; k++)
				{
					glcdWriteDataLine("\x00\x00\x00\x00\x00", 4, dialog_main_page, i*28 + k * 4);
					glcdWriteDataLine("\x00\x00\x00\x00\x00", 4, dialog_main_page+1, i*28 + k * 4);
				}
			}
		}

		dialog_main_last_selected_item = sitem;
	}
}



void dialogMainshowStatus()
{
	if(enable_flip)
	{
		glcdWrite("Flip Control enabled ", 1, 1);
		uiSetRouting(UI_ROUTE_ACCELEROMETER_COMMANDS_EXTERNAL, 1);
	}
	else
	{
		glcdWrite("Flip Control disabled", 1, 1);
		uiSetRouting(UI_ROUTE_ACCELEROMETER_COMMANDS_EXTERNAL, 0);	
	}

	if(enable_xdi)
	{
		glcdWrite("XDI Control enabled ", 2, 1);
		uiSetRouting(UI_ROUTE_XDI_COMMANDS_EXTERNAL, 1);
	}
	else
	{
		glcdWrite("XDI Control disabled", 2, 1);
		uiSetRouting(UI_ROUTE_XDI_COMMANDS_EXTERNAL, 0);
	}

	if(enable_cap)
	{
		glcdWrite("CAP Control enabled ", 0, 1);
		uiSetRouting(UI_ROUTE_CAPACITIVE_COMMANDS_EXTERNAL, 1);
	}
	else
	{
		glcdWrite("CAP Control disabled", 0, 1);
		uiSetRouting(UI_ROUTE_CAPACITIVE_COMMANDS_EXTERNAL, 0);
	}
		
}


void dialogMainTifCallback(unsigned int x, unsigned int y, unsigned char uid)
{
	if(uid == 1)
	{
		enable_cap = true;
	}
	else if(uid == 2)
	{
		enable_flip = true;
	}
	else if(uid == 3)
	{
		enable_xdi = true;
	}

	if(uid == 4)
	{
		enable_cap = false;
	}
	else if(uid == 5)
	{
		enable_flip = false;
	}
	else if(uid == 6)
	{
		enable_xdi = false;
	}

	dialogMainshowStatus();
}


void dialogMainCommandCallback(unsigned char command)
{
/*
	if(command == UI_WHEEL_FORWARD)
	{
		dialogMainMenu(dialog_main_last_selected_item+1);
	}
	else if(command == UI_WHEEL_BACK)
	{
		dialogMainMenu(dialog_main_last_selected_item-1);	
	}
	else if(command == UI_KEY_OK)
	{
		char data[32];
		sprintf(data, "OK %3i", dialog_main_last_selected_item);
		glcdWrite(data, 3, 1);
	}
*/
}

void dialogMainSetupUi()
{
	tifInit(dialogMainTifCallback);

	
	tifEventRegister(1, 0, 48, 16,16);
	tifEventRegister(2, 50, 48, 16,16);
	tifEventRegister(3, 112, 48, 16,16);	
	tifEventRegister(4, 0, 32, 16,16);
	tifEventRegister(5, 50, 32, 16,16);
	tifEventRegister(6, 112, 32, 16,16);	

	uiSetCommandHandler(dialogMainCommandCallback);
	uiSetPositionHandler(tifEventCallback);

	uiSetRouting(UI_ROUTE_TOUCH_POSITION_INTERNAL, 1);
	uiSetRouting(UI_ROUTE_TOUCH_POSITION_EXTERNAL, 0);
	uiSetRouting(UI_ROUTE_CAPACITIVE_COMMANDS_INTERNAL, 0);
	uiSetRouting(UI_ROUTE_CAPACITIVE_COMMANDS_EXTERNAL, 0);
	uiSetRouting(UI_ROUTE_XDI_COMMANDS_INTERNAL, 0);
	uiSetRouting(UI_ROUTE_XDI_COMMANDS_EXTERNAL, 0);
	uiSetRouting(UI_ROUTE_XDI_POSITION_INTERNAL, 0);
	uiSetRouting(UI_ROUTE_XDI_POSITION_EXTERNAL, 0);
	uiSetRouting(UI_ROUTE_ACCELEROMETER_COMMANDS_INTERNAL, 0);
	uiSetRouting(UI_ROUTE_ACCELEROMETER_COMMANDS_EXTERNAL, 0);

	//00A09617A764
}

void dialogMain()
{
	dialogMainSetupUi();

	glcdClearScreen();
	dialog_main_last_selected_item = 0;
	dialogMainMenu(2);
	dialogMainshowStatus();
}
