#include <avr/io.h>
#include "../blib/config.h"
#include "../blib/default.h"
#include "../glcd/glcd.h"
#include "../glcd/multiline.h"
#include "../blib/rs232.h"
#include "../glcd/bmp.h"
#include "btsearch.h"
#include <string.h>

char btsearch_name[16][16];

unsigned char btwait4(char data[6]) //OK\r\n\r\n
{
	unsigned char temp[32];
	unsigned char i, k, ok;

	for(i = 0; i > 32; i++)
	{
		temp[i] = rs232Getchar(0);
		
		ok = true;

		for(k = 0; data[k] != 0 && k < 16; k++)
		{
			if(data[k] != temp[i-6+k])
			{
				ok = false;
			}
		}
		
		if(ok)
		{
			break;
		}
	}
}


unsigned char btsearch()
{
	glcdClearScreen();

	unsigned int screen_x, screen_y;
	unsigned char position = 0;
	char btsearch_temp[500];
	char worte[17][2][13];
	char tmp[1];
	unsigned int i=0,k,j,x;
	int lent;		
	//daten holen	


	bmpLoad("btdown.bmp", 6, 112);
	bmpLoad("btup.bmp",   0, 112);	
	bmpLoad("btok.bmp",   4, 112);
	bmpLoad("btback.bmp", 2, 112);

	rs232Write(0, "+++\r\n");
	rs232Write(0, "ATDI,16,00000000\r\n");

	btwait4("OK\r\n\r\n");
	
	for(i = 0; ; i++)
	{
		rs232Read(0, tmp, 1, 0);
		btsearch_temp[i] = tmp[0];
		
		if (i>5)
		{
			if (btsearch_temp[i] == '\n' && btsearch_temp[i-1] == '\r' &&
				btsearch_temp[i-2] == 'E' && btsearch_temp[i-3] == 'N' &&
				btsearch_temp[i-4] == 'O' && btsearch_temp[i-5] == 'D')
			{
				lent = i-6;
				break;	
			}
		}			
	}
	

	for(int i = 0 ; i < 17 ; i++)
	{
    	for(int k = 0 ; k  < 2 ; k++)
    	{
        	worte[i][k][0] = 0;
    	}
	}

	unsigned int a = 0;
	unsigned int b = 0;
	unsigned int c = 0;

	for(i=0;i<=lent;i++)
	{   
    	if(btsearch_temp[i]==13 && btsearch_temp[i+1]==10)	//suche nach \r\n
    	{
        	worte[a][b][c] = 0;   //letztes element 0 setzen
			a++;
        	b=0;
        	c=0;
			i++;
    	}
		else if(btsearch_temp[i] == ',')
		{
			worte[a][b][c] = 0;
			b++;
			c=0;
		}
    	else
    	{
       		worte[a][b][c++] = btsearch_temp[i];
 	   	}	

	}


	for (i = 0; i < a; i++)
	{
		if(worte[i][0][0] != 0 && worte[i][1][0] != 0)
		{
			sprintf(btsearch_temp, "ATRRN,%s\r\n", worte[i][0]);
			rs232Write(0,btsearch_temp);
			
			btwait4("OK\r\n\r\n");

			for(k = 0; ;k++)
			{
				btsearch_name[i][k] = rs232Getchar(0);
			
				if(btsearch_name[i][k] == '\r')
				{
					btsearch_name[i][k] = 0;
					break;
				}

			}
		}
	}


	rs232Write(0,"ATMD\r\n");

	btsearch_paintlist(0);  //startindex mit 0 begonnen

	while(1)
	{

		screen_x = touchReadX();
		screen_y = touchReadY();


		if(touchInArea(screen_x, screen_y, 112, 0, 128, 15))
		{
			if (position>0)
			{
			position = position-1;
			}
			btsearch_paintlist(position);		 
		}
		if(touchInArea(screen_x, screen_y, 112, 16, 128, 31))
		{
			return;
		}	
		if(touchInArea(screen_x, screen_y, 112, 32, 128, 47))
		{
			//OK
		}
		if(touchInArea(screen_x, screen_y, 112, 48, 128, 64))
		{
			if (position<16)
			{
			position = position+1;
			}
			btsearch_paintlist(position);
		}
		mSleep(200);
	}
}

void btsearch_paintlist(char startindex)	//startindex wird bergeben
{

	glcdWrite("                ",1,1); //16 leerzeichen fr 16 positionen
	glcdWrite("                ",2,1);
	glcdWrite("                ",3,1);
	glcdWrite("                ",4,1);
	glcdWrite("                ",5,1);
	glcdWrite("                ",6,1);

	glcdWrite(btsearch_name[startindex],   1,1);
	glcdWrite(btsearch_name[startindex+1], 2,1);
	glcdWrite(btsearch_name[startindex+2], 3,1);
	glcdWrite(btsearch_name[startindex+3], 4,1);
	glcdWrite(btsearch_name[startindex+4], 5,1);
	glcdWrite(btsearch_name[startindex+5], 6,1);
	
}
