
#ifndef _SDFAT_H

	#include "sdfat.h"
	#include "dos.h"
	#include <avr/io.h>
	#include <avr/delay.h>
	#include "../blib/rs232.h"

	
	inline void sdfatInit()
	{
		MMC_IO_Init();
	}

	inline void sdfatLoad()
	{
		int i = 0;
		for(i = 0; GetDriveInformation() != F_OK && i < 100; i++)
		{
			MMC_CS_ON();
			_delay_ms(5);
			MMC_CS_OFF();
			_delay_ms(5);
			MMC_CS_ON();
			printf("Error failed to get drive info!\n");
		}
	}

	unsigned int sdfatCapacity()
	{
		return MMCCardCapacity()>>11;
	}

	inline unsigned char sdfatOpen(char *name, unsigned char flag)
	{
		return Fopen(name, flag);
	}

	inline unsigned char sdfatSeek(int offset, unsigned char mode)
	{
		return Fseek(offset, mode);
	}

	inline unsigned int sdfatRead(unsigned char *buf, unsigned int count)
	{
		return Fread(buf,count);
	}

	inline unsigned int sdfatWrite(unsigned char *buf, unsigned int count)
	{
		return Fwrite(buf,count);
	}

	inline void sdfatClose()
	{
		Fclose();
	}

#endif 
	
	
