
#include "multiline.h"
#include "glcd.h"


#define MULTILINE_MAX_LINES 7
#define MULTILINE_MAX_CHARS 24

unsigned char multiline_data[MULTILINE_MAX_LINES][MULTILINE_MAX_CHARS+1];
unsigned char multiline_index;


void multilineAdd(char *data)
{
	unsigned char i, k;

	if(multiline_index > MULTILINE_MAX_LINES)
	{
		for(i = 0; i < MULTILINE_MAX_LINES; i++)
		{
			for(k = 0; k < MULTILINE_MAX_CHARS; k++)
			{
				multiline_data[i][k] = multiline_data[i+1][k];
			}
		}
		multiline_index = MULTILINE_MAX_LINES;
	}

	for(k = 0; (i = *data++) && k < MULTILINE_MAX_CHARS; k++) 
	{
		multiline_data[multiline_index][k] = i;	
	}
	multiline_data[multiline_index][k] = 0;

	multiline_index++;

	multilinePaint();
}

void multilinePaint()
{
	unsigned char i;

	for(i = 0; i < multiline_index; i++)
	{
		glcdWrite("                       ", i, 4);
		glcdWrite(multiline_data[i], i, 4);
	}
}
