#ifndef _SIE_H
	#define _SIE_H

#define SIE_COUNT 2
#define SIE_BUFFER_SIZE 2
#define SIE_MAX_PACKET_SIZE 128
#define SIE_CONTROL_BYTES 5
#define SIE_MAX_PACKET_LENGTH (SIE_MAX_PACKET_SIZE + SIE_CONTROL_BYTES)

typedef struct
{
	unsigned int pid;
	unsigned char command;
	unsigned char length;
	unsigned char data[SIE_MAX_PACKET_SIZE];
	unsigned char crc;

} siePacket;

typedef unsigned char sieRawPacket[SIE_MAX_PACKET_LENGTH];

typedef enum
{
	SIE_IDLE,
	SIE_RECEIVING,
	SIE_ESCAPING

} sieState;

typedef enum
{
	SIE_ILLEGAL_FRAMESTART,
	SIE_ILLEGAL_ESCAPE_SEQUENCE,
	SIE_CRC_CHECK_FAILED
} sieError;

typedef enum
{
	SIE_NORMAL,
	SIE_ANSWER
} siePacketType;


void sieInit();

unsigned char sieCreate(void (*receive_callback)(siePacket), void (*send_callback)(unsigned char), void (*error_callback)(unsigned char));

void sieSubmitPacket(unsigned char sie_id, siePacket data);

void sieSubmit(unsigned char sie_id, unsigned char command, unsigned char length, unsigned char *data);

void sieRespond(unsigned char sie_id, unsigned char pid, unsigned char command, unsigned char length, unsigned char *data);

void sieReceive(unsigned char sie_id, unsigned char data);

#endif
