#include "Accelerometer.h"
#include "Ui.h"
#include "../blib/i2c.h"
#include "../glcd/glcd.h"
#include <stdio.h>

void (*accelerometer_ui_callback)(unsigned char command);
unsigned char accelerometer_last_command = 0;


void accelerometerInit(void (*ui_callback)(unsigned char command))
{
	accelerometer_ui_callback = ui_callback;

	i2cInit();
	i2cRegisterWrite(ACCELEROMETER_SLAVE_ADDRESS, 0x20, B8(110001111));
}

void accelerometerMain()
{
	int x, y, z;

	x = i2cRegisterRead(ACCELEROMETER_SLAVE_ADDRESS, 0x28);
	x |= i2cRegisterRead(ACCELEROMETER_SLAVE_ADDRESS, 0x29) << 8;
	y = i2cRegisterRead(ACCELEROMETER_SLAVE_ADDRESS, 0x2A);
	y |= i2cRegisterRead(ACCELEROMETER_SLAVE_ADDRESS, 0x2B) << 8;
	z = i2cRegisterRead(ACCELEROMETER_SLAVE_ADDRESS, 0x2C);
	z |= i2cRegisterRead(ACCELEROMETER_SLAVE_ADDRESS, 0x2D) << 8;


	x -= 500; //Remove offset
	y -= 500; //Remove offset
	z += 620; //Remove gravity

	unsigned char command = 0;

	if(y < -ACCELEROMETER_TRIGGER_Y) //Up
	{
		command = UI_4WAY_UP;
	}
	else if(y > ACCELEROMETER_TRIGGER_Y)
	{
		command = UI_4WAY_DOWN;
	}
	else if(x < -ACCELEROMETER_TRIGGER_X)
	{
		command = UI_4WAY_RIGHT;
	}
	else if(x > ACCELEROMETER_TRIGGER_X)
	{
		command = UI_4WAY_LEFT;
	}

	if(command != accelerometer_last_command)
	{
		accelerometer_last_command = command; 
		if(command != 0)
		{
			accelerometer_ui_callback(command);
		}
	}
}
