#include "CapInterface.h"
#include "QT1106.h"
#include "../blib/default.h"
#include "../blib/timer.h"
#include "../blib/rs232.h"


#define TOUCHKEY_MASK_BUTTON0 B8(00000010)

unsigned char capif_touchwheel_pressed = false, capif_touchkeys_state = 0;
char capif_touchwheel_position = -1;


void (*capif_ui_callback)(capInterfaceKey key_identifier, char value);

void capInterfaceInit(void (*ui_callback)(capInterfaceKey, char))
{
	/* Set Callback */
	capif_ui_callback = ui_callback;
	
	/* Initialize Quantum QT1106 */
	InitQt1106();
	SetQt1106CommsMode( QT_COMMS_MODE_POLL_ALWAYS, 50 );
	SetQtCommandField (SET_QT_MODE, QT_MODE_FREE_RUN); 	
	SetQtCommandField (SET_QT_SLD, QT_MODE_SLIDER); 
	SetQtCommandField (SET_QT_AKS, QT_AKS_DISABLED);//QT_AKS_K_PLUS_W_S 
	SetQtCommandField (SET_QT_RESOLUTION, QT_RESOLUTION_2); 
	SetQtCommandField (SET_QT_DI, QT_DI_6_DETECTS); 
	SetQtCommandField (SET_QT_MOD, QT_MOD_INFINITE);
	SetQtCommandField (SET_QT_PROX, QT_PROX_ON);
	ProcessQt1106();
}

/*
unsigned char capInterfaceHysteresis(char pos1, char pos2)
{
	if(pos2 == -1) //No old pos2
	{
		return 1;
	}
	else if(pos1 - pos2 > 2 || pos2 - pos1 > 2)
	{
		return 1;
	}
	return 0;
}
*/

void capInterfaceMain()
{
	unsigned char TouchStatus;
	unsigned char TouchKeyStates;
	unsigned char TouchWheelPosition;

	TouchStatus = GetQtStatus( QT_FLAG_STATE );
	TouchKeyStates = GetQtStatus( QT_KEY_STATE );
	TouchWheelPosition = GetQtStatus( QT_WHEEL_POSITION );

	if(TouchKeyStates != capif_touchkeys_state)
	{		
		if(TouchKeyStates & TOUCHKEY_MASK_BUTTON0)
		{
			if(!(capif_touchkeys_state & TOUCHKEY_MASK_BUTTON0)) //Key wan't pressed before
			{
				capif_ui_callback(CAPIF_KEY_OK, 0);
			}
			
		}

		capif_touchkeys_state = TouchKeyStates;
	}

	if(TouchKeyStates & B8(10000000) && !capif_touchwheel_pressed)
	{
		capif_touchwheel_pressed = true;			
	}
	else if(!(TouchKeyStates & B8(10000000)) && capif_touchwheel_pressed)
	{
		capif_touchwheel_position = -1;

		capif_touchwheel_pressed = false;
	}
	
	if(capif_touchwheel_pressed && capif_touchwheel_position != TouchWheelPosition)
	{
		if(capif_touchwheel_position != (char)-1) //-1?? doesn't work
		{
			capif_ui_callback(CAPIF_WHEEL, (capif_touchwheel_position) < (TouchWheelPosition)?-1:1);
		}
		capif_touchwheel_position = TouchWheelPosition;
	}
}
