#ifndef __WII_IR_SENSOR_H
#define __WII_IR_SENSOR_H
//-----------------------------------------------------------------------------

#include "../blib/default.h"
#include "../blib/i2c.h"
#include <util/delay.h>

#define IRS_IIR_COEFF 0.75
#define IRS_IIR_DIFF_COEFF (1.00001 - IRS_IIR_COEFF)
#define IRS_SALVE_ADDR 0xB0
#define IRS_I2C_BUFFER_SIZE 0x10
#define IRS_MAX_POINTS 0x04
#define IRS_ACCESS_DELAY_MS 1
//-----------------------------------------------------------------------------

typedef struct sWII_POINT
{
  unsigned int xpos;
  unsigned int ypos;
} tWII_POINT;

typedef struct sWII_IIR_POINT
{
  float xpos;
  float ypos;
} tWII_IIR_POINT;
//-----------------------------------------------------------------------------

extern unsigned char irs_data[IRS_I2C_BUFFER_SIZE];
extern tWII_POINT irs_points[IRS_MAX_POINTS];
extern tWII_IIR_POINT irs_iir_points[IRS_MAX_POINTS];
//-----------------------------------------------------------------------------

void irsInit(void);
void irsRead(void);
void irsDecrypt(void);
void irsConvert(void);
void irsUpdate(void);
unsigned char irsPresent(unsigned char init);
//-----------------------------------------------------------------------------

#endif
