#include "Tif.h"

void (*tif_callback)(unsigned int, unsigned int, unsigned char);
TifEvent tif_event_store[32];
unsigned char tif_event_count = 0;

void tifInit(void (*callback)(unsigned int, unsigned int, unsigned char))
{
	tif_callback = callback;

	tifEventClearAll();
}

unsigned char tifEventRegister(unsigned char uid, unsigned int x, unsigned int y, unsigned int width, unsigned int height)
{
	tif_event_store[tif_event_count].uid = uid;
	tif_event_store[tif_event_count].x = x;
	tif_event_store[tif_event_count].y = y;
	tif_event_store[tif_event_count].width = width;
	tif_event_store[tif_event_count].height = height;

	return tif_event_count++;		
}
void tifEventClearAll()
{
	unsigned char i = 0;

	for(i = 0; i < TIF_MAX_EVENTS; i++)
	{
		tif_event_store[i].uid = 0;
		tif_event_store[i].x = 0;
		tif_event_store[i].y = 0;
		tif_event_store[i].width = 0;
		tif_event_store[i].height = 0;
	}

	tif_event_count = 0; 
}
void tifEventClear(unsigned char event)
{
	tif_event_store[event].uid = 0;		
}

unsigned char tifInArea(unsigned char screen_x, unsigned char screen_y, unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2)
{
	if(screen_x >= x1 && screen_x <= x2 && screen_y >= y1 && screen_y <= y2)
	{
		return 1;
	}
	return 0;
}


void tifEventCallback(unsigned int x, unsigned int y, unsigned char mask)
{
	unsigned char i = 0;

	for(i = 0; i < tif_event_count; i++)
	{
		if(tifInArea(x, y, tif_event_store[i].x, tif_event_store[i].y, tif_event_store[i].x + tif_event_store[i].width, tif_event_store[i].y + tif_event_store[i].height))
		{
			tif_callback(x, y, tif_event_store[i].uid);
		}
	}
}
