#ifndef _TOUCH_H
	#define _TOUCH_H
	
	#define TOUCH_PORT_ADC PORTF
	#define TOUCH_DDR_ADC DDRF
	#define TOUCH_PIN_Y1 1
	#define TOUCH_PIN_Y2 3
	#define TOUCH_PIN_X1 0
	#define TOUCH_PIN_X2 2

	#define TOUCH_SCREEN_HEIGHT 1000
	#define TOUCH_SCREEN_WIDTH 1000
	#define TOUCH_X_ADC_START 100
	#define TOUCH_X_ADC_END 800
	#define TOUCH_Y_ADC_START 180
	#define TOUCH_Y_ADC_END 720

	#define TOUCH_Y_ADC_HEIGHT (TOUCH_Y_ADC_END - TOUCH_Y_ADC_START)
	#define TOUCH_X_ADC_WIDTH (TOUCH_X_ADC_END - TOUCH_X_ADC_START)

	#define TOUCH_MIDDLE_VALUES 20

	//FLAGS
	#define TOUCH_NOT_PRESSED 0xFFFF

	unsigned int touch_last_x = TOUCH_NOT_PRESSED;
	unsigned int touch_last_y = TOUCH_NOT_PRESSED;

	/* 
	 * Initialize touch screen
	 * @param position_callback Callback function, to be called if the pressed position changes
	 */
	void touchInit(void (*position_callback)(unsigned int, unsigned int, unsigned char));

	/* Private */

	void touchStart();

	void touchStop();

	void touchAdcCallback(unsigned int value);

	unsigned int touchReadX();

	unsigned int touchReadY();

#endif
